Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm > Class Template Reference
Other available functionality » Set propagators

Reified subset propagator More...

`#include <rel.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as ternary low).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, View0 x, View1 y, CtrlView b)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| ReSubset (Space &home, ReSubset &p)
| Constructor for cloning p.
| ReSubset (Home home, View0 x0, View1 x1, CtrlView b)
| Constructor for posting.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

View0 | x0
| Variable view.
View1 | x1
| Variable view.
CtrlView | b
| Boolean control view.

## Detailed Description

template<class View0, class View1, class CtrlView, ReifyMode rm>
class Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >

Reified subset propagator

Requires

#include <gecode/set/rel.hh>
rel.hh

Definition at line 115 of file rel.hh.

## Constructor & Destructor Documentation

## ReSubset() [1/2]

template<class View0, class View1, class CtrlView, ReifyMode rm>

Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::ReSubset | ( | Space & | home,
|  | ReSubset< View0, View1, CtrlView, rm > & | p )

inline protected

Constructor for cloning p.

Definition at line 50 of file re-subset.hpp.

## ReSubset() [2/2]

template<class View0, class View1, class CtrlView, ReifyMode rm>

Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::ReSubset | ( | Home | home,
|  | View0 | x0,
|  | View1 | x1,
|  | CtrlView | b )

inline protected

Constructor for posting.

Definition at line 40 of file re-subset.hpp.

## Member Function Documentation

## copy()

template<class View0, class View1, class CtrlView, ReifyMode rm>

Actor * Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 97 of file re-subset.hpp.

## cost()

template<class View0, class View1, class CtrlView, ReifyMode rm>

PropCost Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as ternary low).

Implements Gecode::Propagator.

Definition at line 60 of file re-subset.hpp.

## reschedule()

template<class View0, class View1, class CtrlView, ReifyMode rm>

void Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 67 of file re-subset.hpp.

## dispose()

template<class View0, class View1, class CtrlView, ReifyMode rm>

size_t Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 75 of file re-subset.hpp.

## propagate()

template<class View0, class View1, class CtrlView, ReifyMode rm>

ExecStatus Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 103 of file re-subset.hpp.

## post()

template<class View0, class View1, class CtrlView, ReifyMode rm>

ExecStatus Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::post | ( | Home | home,
|  | View0 | x,
|  | View1 | y,
|  | CtrlView | b )

static

Post propagator for .

Definition at line 85 of file re-subset.hpp.

## Member Data Documentation

## x0

template<class View0, class View1, class CtrlView, ReifyMode rm>

View0 Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::x0

protected

Variable view.

Definition at line 118 of file rel.hh.

## x1

template<class View0, class View1, class CtrlView, ReifyMode rm>

View1 Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::x1

protected

Variable view.

Definition at line 120 of file rel.hh.

## b

template<class View0, class View1, class CtrlView, ReifyMode rm>

CtrlView Gecode::Set::Rel::ReSubset< View0, View1, CtrlView, rm >::b

protected

Boolean control view.

Definition at line 122 of file rel.hh.

The documentation for this class was generated from the following files:

- gecode/set/rel.hh
- gecode/set/rel/re-subset.hpp